
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.5.4">
    
    
      
        <title>File-based configuration - Eclipse Hawk™</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.80dcb947.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#7e56c2">
        
      
      

    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
<!-- FAVICON -->
<link rel="apple-touch-icon" sizes="180x180" href="../../assets/images/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="../../assets/images/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="../../assets/images/favicon-16x16.png">
<link rel="mask-icon" href="../../assets/images/safari-pinned-tab.svg" color="#5bbad5">
<link rel="shortcut icon" href="../../assets/images/favicon.ico">
<meta name="msapplication-TileColor" content="#b91d47">
<meta name="msapplication-config" content="../../assets/images/browserconfig.xml">
<meta name="theme-color" content="#ffffff">

  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="deep-purple" data-md-color-accent="deep-purple">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#format" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="../.." title="Eclipse Hawk™" class="md-header__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Eclipse Hawk™
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              File-based configuration
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
      </div>
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Eclipse Hawk™" class="md-nav__button md-logo" aria-label="Eclipse Hawk™" data-md-component="logo">
      
  <img src="../../assets/images/hawk-logo-white.svg" alt="logo">

    </a>
    Eclipse Hawk™
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2022 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Git repository @ Eclipse
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Home
      </a>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" >
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Basic use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Basic use" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Basic use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/installation/" class="md-nav__link">
        Installation
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/core-concepts/" class="md-nav__link">
        Core concepts
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/examples-xmi/" class="md-nav__link">
        Examples (XMI)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/examples-modelio/" class="md-nav__link">
        Examples (Modelio)
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../basic-use/papyrus/" class="md-nav__link">
        Papyrus UML support
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" >
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Advanced use
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Advanced use" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Advanced use
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/graph-as-emf/" class="md-nav__link">
        Graph as EMF model
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/advanced-props/" class="md-nav__link">
        Advanced properties
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/meta-queries/" class="md-nav__link">
        Meta-level queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/temporal-queries/" class="md-nav__link">
        Temporal queries
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../advanced-use/oomph/" class="md-nav__link">
        Oomph and Hawk
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Server
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Server" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Server
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../architecture/" class="md-nav__link">
        Architecture
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../api/" class="md-nav__link">
        Thrift API
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../api-security/" class="md-nav__link">
        Thrift API security
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../deployment/" class="md-nav__link">
        Deployment
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../cli/" class="md-nav__link">
        Console client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../eclipse/" class="md-nav__link">
        Eclipse client
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../other-languages/" class="md-nav__link">
        Cross-language clients
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          File-based configuration
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        File-based configuration
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#format" class="md-nav__link">
    Format
  </a>
  
    <nav class="md-nav" aria-label="Format">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#table-1-list-of-xml-elements-in-configuration-file" class="md-nav__link">
    Table 1: List of XML elements in configuration file
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-2-hawk-attributes" class="md-nav__link">
    Table 2:     ‘hawk’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-3-delay-attributes" class="md-nav__link">
    Table 3:     ‘delay’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-4-plugin-attributes" class="md-nav__link">
    Table 4:     ‘plugin’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-5-metamodel-attributes" class="md-nav__link">
    Table 5:     ‘metamodel’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-6-repository-attributes" class="md-nav__link">
    Table 6:     ‘repository’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-7-derivedattribute-attributes" class="md-nav__link">
    Table 7:    ‘derivedAttribute’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-8-derivation-attributes" class="md-nav__link">
    Table 8:     ‘derivation’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-9-indexedattribute-attributes" class="md-nav__link">
    Table 9:     ‘indexedAttribute’ attributes
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#location" class="md-nav__link">
    Location
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#how-to-useenable-hawk-instance-configuration-engine" class="md-nav__link">
    How to use/enable Hawk instance configuration engine
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#usage-notes" class="md-nav__link">
    Usage Notes
  </a>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../logging/" class="md-nav__link">
        Logging
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" >
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Developers
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Developers" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Developers
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/run-from-source/" class="md-nav__link">
        Run GUI from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/server-from-source/" class="md-nav__link">
        Run Server from source
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/plain-maven/" class="md-nav__link">
        Build with plain Maven
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../developers/website/" class="md-nav__link">
        Work on the website
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Community
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Community" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Community
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://www.eclipse.org/forums/index.php/f/442/" class="md-nav__link">
        Forum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues/new" class="md-nav__link">
        File a bug
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://gitlab.eclipse.org/eclipse/hawk/hawk/-/issues" class="md-nav__link">
        Open bugs
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="https://ci.eclipse.org/hawk/" class="md-nav__link">
        Builds
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../../additional-resources/" class="md-nav__link">
        Additional resources
      </a>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#format" class="md-nav__link">
    Format
  </a>
  
    <nav class="md-nav" aria-label="Format">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#table-1-list-of-xml-elements-in-configuration-file" class="md-nav__link">
    Table 1: List of XML elements in configuration file
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-2-hawk-attributes" class="md-nav__link">
    Table 2:     ‘hawk’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-3-delay-attributes" class="md-nav__link">
    Table 3:     ‘delay’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-4-plugin-attributes" class="md-nav__link">
    Table 4:     ‘plugin’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-5-metamodel-attributes" class="md-nav__link">
    Table 5:     ‘metamodel’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-6-repository-attributes" class="md-nav__link">
    Table 6:     ‘repository’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-7-derivedattribute-attributes" class="md-nav__link">
    Table 7:    ‘derivedAttribute’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-8-derivation-attributes" class="md-nav__link">
    Table 8:     ‘derivation’ attributes
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#table-9-indexedattribute-attributes" class="md-nav__link">
    Table 9:     ‘indexedAttribute’ attributes
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#location" class="md-nav__link">
    Location
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#how-to-useenable-hawk-instance-configuration-engine" class="md-nav__link">
    How to use/enable Hawk instance configuration engine
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#usage-notes" class="md-nav__link">
    Usage Notes
  </a>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  


  <h1>File-based configuration</h1>

<p>Hawk server includes an API to add Hawk instances that are used to index and query models. The configuration engine allows the server to create and configure Hawk instances as per user-created configuration files. The server should be ready to receive user queries upon startup without any interaction from user or clients. 
Upon startup, Hawk server reads and parses configuration files, and then it creates/updates hawk instances as per configuration files. </p>
<p>NOTE: the Hawk server no longer writes to configuration files. If an instance configuration changes during operation, this configuration is persisted through the current HawkConfig mechanism. Configuration files will not overwrite any of the changed settings. The only exception is the polling min/max which will revert to config file settings if a server is restarted.</p>
<h2 id="format">Format<a class="headerlink" href="#format" title="Permanent link">&para;</a></h2>
<p>Configuration files are XML files that define hawk instance name and its configuration. An XML schema can be found at
<a href="https://github.com/Orjuwan-alwadeai/mondo-hawk/releases/download/v1.1.0-201708-interim/HawkServerConfigurationSchema.xsd">HawkServerConfigurationSchema.xsd</a>. A sample configuration file can be found at <a href="https://github.com/Orjuwan-alwadeai/mondo-hawk/releases/download/v1.1.0-201708-interim/Sample_config_file.xml">Sample Configuration File</a></p>
<p>The XML should include the following elements:</p>
<h3 id="table-1-list-of-xml-elements-in-configuration-file">Table 1: List of XML elements in configuration file<a class="headerlink" href="#table-1-list-of-xml-elements-in-configuration-file" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Parent Element Name</th>
<th>multiplicity</th>
<th>Value</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td>‘hawk’</td>
<td>xml</td>
<td>1</td>
<td>None</td>
<td>Root element</td>
</tr>
<tr>
<td>‘delay’</td>
<td>‘hawk’</td>
<td>1</td>
<td>None</td>
<td>Polling configuration</td>
</tr>
<tr>
<td>‘plugins’</td>
<td>‘hawk’</td>
<td>0-1</td>
<td>None</td>
<td>List of plugins (to be/that are) enabled</td>
</tr>
<tr>
<td>‘plugin’</td>
<td>‘plugins’</td>
<td>0-*</td>
<td>None</td>
<td>Plugin name</td>
</tr>
<tr>
<td>‘metamodels’</td>
<td>‘hawk’</td>
<td>0-1</td>
<td>None</td>
<td>List of metamodels (to be/that are) registered</td>
</tr>
<tr>
<td>‘metamodel’</td>
<td>‘metamodels’</td>
<td>0-*</td>
<td>None</td>
<td>Metamodel parameters</td>
</tr>
<tr>
<td>‘repositories’</td>
<td>‘hawk’</td>
<td>0-1</td>
<td>None</td>
<td>List of repositories (to be/that are) added</td>
</tr>
<tr>
<td>‘repository’</td>
<td>‘repositories’</td>
<td>0-*</td>
<td>None</td>
<td>Repository parameters</td>
</tr>
<tr>
<td>‘derivedAttributes’</td>
<td>‘hawk’</td>
<td>0-1</td>
<td>None</td>
<td>List of derived attributes (to be/that are) added</td>
</tr>
<tr>
<td>‘derivedAttribute’</td>
<td>‘derivedAttributes’</td>
<td>0-*</td>
<td>None</td>
<td>Derived attribute parameters</td>
</tr>
<tr>
<td>‘derivation’</td>
<td>‘derivedAttribute’</td>
<td>0-1</td>
<td>None</td>
<td>Derivation parameters</td>
</tr>
<tr>
<td>‘logic’</td>
<td>‘derivation’</td>
<td>0-1</td>
<td>CDATA section</td>
<td>An executable expression of the derivation logic in the language specified.</td>
</tr>
<tr>
<td>‘indexedAttributes’</td>
<td>‘hawk’</td>
<td>0-1</td>
<td>None</td>
<td>List of indexed attributes (to be/that are) added</td>
</tr>
<tr>
<td>‘indexedAttribute’</td>
<td>‘indexedAttributes’</td>
<td>0-*</td>
<td>None</td>
<td>Indexed attribute parameters</td>
</tr>
</tbody>
</table>
<h3 id="table-2-hawk-attributes">Table 2:     ‘hawk’ attributes<a class="headerlink" href="#table-2-hawk-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘hawk’</strong></td>
<td>‘name’</td>
<td>Required</td>
<td>String</td>
<td>The unique name of the new Hawk instance</td>
</tr>
<tr>
<td></td>
<td>‘backend’</td>
<td>Required</td>
<td>String</td>
<td>The name of the backend to be used (e.g.org.eclipse.hawk.orientdb.OrientDatabase, org.eclipse.hawk.orientdb.RemoteOrientDatabase)</td>
</tr>
</tbody>
</table>
<h3 id="table-3-delay-attributes">Table 3:     ‘delay’ attributes<a class="headerlink" href="#table-3-delay-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘delay’</strong></td>
<td>‘min’</td>
<td>Required</td>
<td>String</td>
<td>Minimum delay between periodic synchronization in milliseconds</td>
</tr>
<tr>
<td></td>
<td>‘max’</td>
<td>Required</td>
<td>String</td>
<td>Maximum delay between periodic synchronization in milliseconds (0 to disable periodic synchronization)</td>
</tr>
</tbody>
</table>
<h3 id="table-4-plugin-attributes">Table 4:     ‘plugin’ attributes<a class="headerlink" href="#table-4-plugin-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘plugin’</strong></td>
<td>‘name’</td>
<td>Required</td>
<td>String</td>
<td>e.g. (org.eclipse.hawk.modelio.exml.listeners.ModelioGraphChangeListener, org.eclipse.hawk.modelio.exml.metamodel.ModelioMetaModelResourceFactory, org.eclipse.hawk.modelio.exml.model.ModelioModelResourceFactory)</td>
</tr>
</tbody>
</table>
<h3 id="table-5-metamodel-attributes">Table 5:     ‘metamodel’ attributes<a class="headerlink" href="#table-5-metamodel-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘metamodel’</strong></td>
<td>‘location’</td>
<td>Optional</td>
<td>String</td>
<td>Location of metamodel file to be registered</td>
</tr>
<tr>
<td></td>
<td>~~‘uri’~~</td>
<td>~~Optional~~</td>
<td>~~String~~</td>
<td>~~Metamodel URI. This value is set automatically by server to list registered metamodels~~</td>
</tr>
</tbody>
</table>
<h3 id="table-6-repository-attributes">Table 6:     ‘repository’ attributes<a class="headerlink" href="#table-6-repository-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘repository’</strong></td>
<td>‘location’</td>
<td>Required</td>
<td>String</td>
<td>Location of the repository</td>
</tr>
<tr>
<td></td>
<td>‘type’</td>
<td>Optional</td>
<td>String</td>
<td>The type of repository available repository types ()</td>
</tr>
<tr>
<td></td>
<td>‘user’</td>
<td>Optional</td>
<td>String</td>
<td>Username for logging into the VCS</td>
</tr>
<tr>
<td></td>
<td>‘pass’</td>
<td>Optional</td>
<td>String</td>
<td>Password for logging into the VCS</td>
</tr>
<tr>
<td></td>
<td>‘frozen’</td>
<td>Optional</td>
<td>String</td>
<td>If the repository is frozen (true/false)</td>
</tr>
</tbody>
</table>
<h3 id="table-7-derivedattribute-attributes">Table 7:    ‘derivedAttribute’ attributes<a class="headerlink" href="#table-7-derivedattribute-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘derivedAttribute’</strong></td>
<td>‘attributeName’</td>
<td>Required</td>
<td>String</td>
<td>The name of the derived attribute</td>
</tr>
<tr>
<td></td>
<td>‘typeName’</td>
<td>Required</td>
<td>String</td>
<td>The name of the type to which the derived attribute belongs</td>
</tr>
<tr>
<td></td>
<td>‘metamodelUri’</td>
<td>Required</td>
<td>String</td>
<td>The URI of the metamodel to which the de- rived attribute belongs</td>
</tr>
<tr>
<td></td>
<td>‘attributeType’</td>
<td>Optional</td>
<td>String</td>
<td>The (primitive) type of the derived attribute</td>
</tr>
<tr>
<td></td>
<td>‘isOrdered’</td>
<td>Optional</td>
<td>String</td>
<td>A flag specifying whether the order of the values of the derived attribute is significant (only makes sense when isMany=true)</td>
</tr>
<tr>
<td></td>
<td>‘isUnique’</td>
<td>Optional</td>
<td>String</td>
<td>A flag specifying whether the the values of the derived attribute are unique (only makes sense when isMany=true)</td>
</tr>
<tr>
<td></td>
<td>‘isMany’</td>
<td>Optional</td>
<td>String</td>
<td>The multiplicity of the derived attribute</td>
</tr>
</tbody>
</table>
<h3 id="table-8-derivation-attributes">Table 8:     ‘derivation’ attributes<a class="headerlink" href="#table-8-derivation-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘derivation’</strong></td>
<td>‘language’</td>
<td>Required</td>
<td>String</td>
<td>The language used to express the derivation logic. Available labguages in Hawk: org.eclipse.hawk.epsilon.emc.EOLQueryEngine, org.eclipse.hawk.orientdb.query.OrientSQLQueryEngine, org.eclipse.hawk.epsilon.emc.EPLQueryEngine</td>
</tr>
</tbody>
</table>
<h3 id="table-9-indexedattribute-attributes">Table 9:     ‘indexedAttribute’ attributes<a class="headerlink" href="#table-9-indexedattribute-attributes" title="Permanent link">&para;</a></h3>
<table>
<thead>
<tr>
<th>Element Name</th>
<th>Attribute name</th>
<th>Optional/Required</th>
<th>Type</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>‘indexedAttribute’</strong></td>
<td>‘attributeName’</td>
<td>Required</td>
<td>String</td>
<td>The name of the indexed attribute.</td>
</tr>
<tr>
<td></td>
<td>‘typeName’</td>
<td>Required</td>
<td>String</td>
<td>The name of the type to which the indexed attribute</td>
</tr>
<tr>
<td></td>
<td>‘metamodelUri’</td>
<td>Required</td>
<td>String</td>
<td>The URI of the metamodel to which the indexed attribute belongs.</td>
</tr>
</tbody>
</table>
<h2 id="location">Location<a class="headerlink" href="#location" title="Permanent link">&para;</a></h2>
<p>Configuration files are expected to be located in the ‘configuration’ folder in the server’s home directory. Each Hawk instance should have its own configuration file. There are no rules on how the file should be named. It is a good practice to include hawk instance name in the file name for easy recognition. 
<img alt="" src="../img/config-file-location.png" /></p>
<h2 id="how-to-useenable-hawk-instance-configuration-engine">How to use/enable Hawk instance configuration engine<a class="headerlink" href="#how-to-useenable-hawk-instance-configuration-engine" title="Permanent link">&para;</a></h2>
<p>You can follow <a href="https://youtu.be/swAgG8v-lLU">this video tutorial</a>, or alternatively follow these steps:</p>
<ol>
<li>Download the hawk-server-*.zip file for your operating system and architecture of choice from <a href="https://github.com/Orjuwan-alwadeai/mondo-hawk/releases/tag/v1.1.0-201708-interim">Hawk Server With Configuration</a>)</li>
<li>Create a configuration file for each instance required to run in the Hawk server. </li>
<li>Edit configuration files: </li>
<li>Set instance name, backend, delay</li>
<li>Add list of plugins to be enabled</li>
<li>Add metamodel file to location to be registered</li>
<li>Add repositories that are to be indexed </li>
<li>Add any required derived attributes</li>
<li>Add any required indexed attributes</li>
<li>Save the configuration files to the ‘configuration’ folder in the server’s home directory (see figure 1)</li>
<li>Perform any other configuration that are required by Hawk Server and start the server, by following the <a href="../deployment/">deployment instructions</a>].</li>
<li>Check if the hawk instances are added and running by typing ‘hawkListInstances’ in the server’s command terminal:
 <img alt="" src="../img/hawklistinstances.png" /></li>
</ol>
<h2 id="usage-notes">Usage Notes<a class="headerlink" href="#usage-notes" title="Permanent link">&para;</a></h2>
<ul>
<li>
<p>Deleting configuration files from the directory will not delete instances from the server. However, the server will not start those instances.</p>
</li>
<li>
<p>To test Hawk server with Measure Platform, refer to <a href="https://github.com/Orjuwan-alwadeai/HawkQuerySMMMMeasureLib/wiki/Using-HawkQueryMeasure--to-query-Hawk-instance-running-in-Hawk-Server">Using HawkQueryMeasure to query Hawk instance running in Hawk Server</a></p>
</li>
</ul>





                
              </article>
            </div>
          
          
        </div>
        
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../other-languages/" title="Cross-language clients" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Cross-language clients
              </span>
            </div>
          </a>
        
        
          <a href="../logging/" title="Logging" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Logging
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            Copyright © Eclipse Foundation, Inc. All Rights Reserved.
          </div>
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">Material for MkDocs</a>
      </div>
      <div class="md-footer-copyright hawk-eclipse-links">
          <ul>
              <li><a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a></li>
              <li><a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a></li>
              <li><a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a></li>
          </ul>
      </div>
      <div class="md-social">
  
</div>
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    <script id="__config" type="application/json">{"base": "../..", "features": [], "search": "../../assets/javascripts/workers/search.5bf1dace.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version.title": "Select version"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.078830c0.min.js"></script>
      
    
  </body>
</html>